/*

Robot

Elever: <ditt namn>

Ursprunglig version: 2014-12-11/Staffan Melin

Kräver NewPing library
http://playground.arduino.cc/Code/NewPing

*/

//
// Vårt program behöver inkludera (lägga till) lite funktionalitet
// Det kallas för bibliotek.
//

#include <Servo.h>
#include <NewPing.h>
#include <SoftwareSerial.h>



//
// konstanter (värden som inte ändras i programmet)
//

int pinLed = 13; // utgång 13 är kopplat till en LED på Arduinon

const int pinVansterMotor1 = 2;
const int pinVansterMotor2 = 3;
const int pinVansterMotorFart = 6;

const int pinHogerMotor1 = 4;
const int pinHogerMotor2 = 5;
const int pinHogerMotorFart = 11;

const int pinServo = 10;

const int pinPingTrig = 19;
const int pinPingEcho = 18;
const int pingMax = 200; // hinder längre bort än pingMax centimeter kommer ej att ses

const int motorFart = 200; // hur snabbt ska motorerna gå?



//
// globala variabler (syns i hela programmet)
//

Servo myServo; // hjälper oss prata med servot
NewPing myPing(pinPingTrig, pinPingEcho, pingMax); // hjälper oss prata med avståndsmätaren

int avstandFramat; // uppnått avstånd framåt
int avstandVanster; // uppått avstånd åt vänster
int avstandHoger; // uppnått avstånd åt höger


//
// funktionen setup() körs EN GÅNG i början av programmet
//
void setup() {                

	pinMode(pinLed, OUTPUT);

	// avståndsmätare (ping = ultraljudssensor)
	// den LÄSER vi av (INPUT)
	// Nedanstående två rader är egentligen onödiga eftersom de görs "inne i" raden NewPing myPing(...) ovan        
	pinMode(pinPingTrig, OUTPUT);
	pinMode(pinPingEcho, INPUT);

	// servo som styr avståndsmätaren
	// den STYR vi
	myServo.attach(pinServo);
	myServo.write(90); // ställ in servot på 90 grader (= rakt fram)

	// vänster motor
	// den STYR vi (OUTPUT)
	pinMode(pinVansterMotor1, OUTPUT);
	pinMode(pinVansterMotor2, OUTPUT);
	pinMode(pinVansterMotorFart, OUTPUT);

	// höger motor
	// den STYR vi (OUTPUT)
	pinMode(pinHogerMotor1, OUTPUT);
	pinMode(pinHogerMotor2, OUTPUT);
	pinMode(pinHogerMotorFart, OUTPUT);

	// sätt igång roboten framåt
	motorFramat();
}



//
// funktionen loop() körs om och om igen (tills strömmen bryts)
//
void loop() {

	digitalWrite(pinLed, 1);

	avstandFramat = myPing.ping_cm();

	// vi bryr oss inte om avstånd som är 0 (för avståndsmätaren visar ibland fel)
	if (avstandFramat > 0)
	{
		// har vi ett hinder framför roboten?
		if (avstandFramat < 25)
		{
			motorStopp();

			// bestäm vad roboten ska göra nu


		}

	}
}

void motorSvangHoger(void)
{
	// stoppa höger motor
	analogWrite(pinHogerMotorFart, 0);

	// kör vänster motor
	analogWrite(pinVansterMotorFart, motorFart);
	digitalWrite(pinVansterMotor1, LOW);
	digitalWrite(pinVansterMotor2, HIGH);
}

void motorSvangVanster(void)
{
	// stoppa vänster motor
	analogWrite(pinVansterMotorFart, 0);

	// kör höger motor
	analogWrite(pinHogerMotorFart, motorFart);
	digitalWrite(pinHogerMotor1, LOW);
	digitalWrite(pinHogerMotor2, HIGH);
}

void motorFramat(void)
{
	// kör vänster motor
	analogWrite(pinVansterMotorFart, motorFart);
	digitalWrite(pinVansterMotor1, LOW);
	digitalWrite(pinVansterMotor2, HIGH);

	// kör även höger motor
	analogWrite(pinHogerMotorFart, motorFart);
	digitalWrite(pinHogerMotor1, LOW);
	digitalWrite(pinHogerMotor2, HIGH);

}

void motorBakat(void)
{

	// kör vänster motor bakåt
	analogWrite(pinVansterMotorFart, motorFart);
	digitalWrite(pinVansterMotor1, HIGH);
	digitalWrite(pinVansterMotor2, LOW);

	// kör höger motor bakåt
	analogWrite(pinHogerMotorFart, motorFart);
	digitalWrite(pinHogerMotor1, HIGH);
	digitalWrite(pinHogerMotor2, LOW);

}

void motorStopp(void)
{
	// stoppa vänster motor
	analogWrite(pinVansterMotorFart, 0);
	digitalWrite(pinVansterMotor1, LOW);
	digitalWrite(pinVansterMotor2, LOW);

	// stoppa höger motor
	analogWrite(pinHogerMotorFart, 0);
	digitalWrite(pinHogerMotor1, LOW);
	digitalWrite(pinHogerMotor2, LOW);

}

